#!/bin/sh

if [ -n "$1" ]; then
    DUAL=$1
else
    DUAL=1
fi

if [ -n "$2" ]; then
    STOP_ON_ERR=$2
else
    STOP_ON_ERR=1
fi

if [ -n "$3" ]; then
    DURATION=$3
fi

if [ -n "$4" ]; then
    reserve=$4
else
    reserve=""
fi


Result=0


#Run DUAL mode
if [ "$DUAL" -eq 1 ]; then
   #Get local IP list
   IP_count=$(ifconfig |grep "inet addr:" | awk 'BEGIN {FS=" +|:"} {print $4}')

   #Check local IP address and decide remote IP address
   for i in ${IP_count[@]}; do
      if [ "${i}" == "192.168.8.101" ]; then
         RemoteIP="192.168.8.100"
         break;
      fi
      if [ "${i}" == "192.168.8.100" ]; then
         RemoteIP="192.168.8.101"
         break;
      fi
   done

   #Execute remote CPU stress
   if [ "$RemoteIP" != "" ]; then
      rcmd -i $RemoteIP -c "killall stress"
      rcmd -i $RemoteIP -c "cpustress.sh 0 $STOP_ON_ERR $DURATION"
   fi
fi

if [ "$reserve" == "r" ]; then
   #Get system CPU number
   CPU_NUM="$(cat /proc/cpuinfo |grep processor | awk 'END {print NR - 1}')"
else
   #Get system CPU number
   CPU_NUM="$(cat /proc/cpuinfo |grep processor | awk 'END {print NR}')"
fi


mkdir -p /tmp/log
rm -f /tmp/log/cpustress_result
now="[$(date '+%D %T')]"
printf "$now Start CPU " >> /tmp/log/cpustress.log
printf "$now Start CPU stress\n" >> /tmp/log/cpustress_result


#Clean MCE log content
lemur cpu utility getmce Processor0 > /dev/null


#Star CPU stress
stress --cpu $CPU_NUM >> /tmp/log/cpustress.log &
START="$(date +%s)"

while [ 1 ]; do
   #Update current time
   CURRENT="$(date +%s)"
   TIME_DIFF=$(( $CURRENT - $START ))

   if [ -f /tmp/stop_flag ]; then
      break;
   fi

   #Stop on error check
   if [ "$STOP_ON_ERR" -eq 1 ]; then
      #Check /dev/mcelog
      lemur cpu utility getmce Processor0 > /tmp/mcelog
      MCElog="$(sed '1q;d' /tmp/mcelog)"
      if [ "$MCElog" != "No MCE error message." ]; then
         cat /tmp/mcelog >> /tmp/log/cpustress.log
         touch /tmp/stop_flag
         Result=1
         break;
      fi
   fi

   #Check duration
   if [ "$DURATION" -ne 0 ]; then
      if [ $TIME_DIFF -ge $DURATION ]; then
         break;
      fi
   fi

done

#print the end time
now="[$(date '+%D %T')]"
printf "$now Stop cpustress.sh\n" >> /tmp/log/cpustress.log


now="[$(date '+%D %T')]"
if [ "$Result" -eq 1 ]; then
   echo "$now FAILD" >> /tmp/log/cpustress_result
else
   echo "$now PASS" >> /tmp/log/cpustress_result
fi


rm -f /tmp/mcelog
pid=`ps -all | grep "stress --cpu" | awk '{print $1}'`
if [ "${pid}" != ""  ]; then
    kill ${pid} >/dev/null 2>&1
fi             

