#!/bin/bash

# monitor the PID
spinnerForPid()
{
    local pid=$1
    local delay=0.75
    local spinstr='|/-\'
    while [ "$(ps a | awk '{print $1}' | grep -w $pid)" ]; do
        local temp=${spinstr#?}
        printf " [%c]  " "$spinstr"
        local spinstr=$temp${spinstr%"$temp"}
        sleep $delay
        printf "\r"
    done
    printf "\r"
}

# Read command from Command list file
if [[ -z "$1" ]]; then
    printf "Usage:\n"
    printf "\t$0 <Command List File>\n"
    exit 0
else
    CmdListFile=$1
fi

line_count=`wc $CmdListFile | awk '{ print $1 }'`

for line in `seq $line_count`
do
    read cmd

    # Execute the command list
    $cmd&

    # store the pid in a list
    pidList="$pidList $!"
done < "$CmdListFile"

# display a spinner to present the stress status
for pid in $pidList
do
    spinnerForPid $pid
done

# display stress result
cat /tmp/log/*result
