/// @file       CommonCLIFunctions.hpp
/// @brief      Common functions for all modules in CLI layer
/// @details    Provide miscellaneous functions for all modules in CLI layer
/// @author     KenHu
/// @copyright  Copyright 2015-2016 Hon Hai Technology Group. All Rights Reserved.

#ifndef COMMON_CLI_FUNCTIONS_HPP
#define COMMON_CLI_FUNCTIONS_HPP

#include "CommonFunctions.hpp"

#define UNKNOWN_COMMAND_MSG     "Error: Unknown command!"
#define UNKNOWN_OPERATION_MSG   "Error: Unknown operation!"
#define SYNTAX_ERROR_MSG        "Error: Syntax error!"

enum DEBUG_LEVEL {
    DEBUG_LEVEL_0 = 0, //No Debug / Error message
    DEBUG_LEVEL_1,     //Show Error message
    DEBUG_LEVEL_2,     //Show Debug / Error message
};

enum RESULT_MESSAGE {
    RESULT_MESSAGE_OFF = 0, //Not to show result message when command is completed
    RESULT_MESSAGE_ON = 1,  //Show RESULT: RESULTED or RESULT: FAILED when command is completed
};

extern DEBUG_LEVEL g_eDebugLevel;
extern RESULT_MESSAGE g_eResultMessage;

extern enum RESULT_MESSAGE getResultMessageConfig(void);
extern void printError(ErrorMsg *in_pErrorMsg);
extern void printError(DEBUG_LEVEL in_eLevel, ErrorMsg *in_pErrorMsg);
extern void setResultMessageConfig(enum RESULT_MESSAGE in_eConfig);

#endif
