#ifndef STRING_PARSER_H
#define STRING_PARSER_H

#include <stdio.h>
#include <iostream>
#include <string>
#include <string.h>

using namespace std;

#define PARAMETERS_NUMBER 7


//Define module type
enum MODULE_TYPE {
    NO_MODULE = 0,
    MODULE_HELP,
    UNSUPPORT,
    I2C_MODULE,
    CPU_MODULE,
    ETHERNET_MODULE,
    BBU_MODULE,
    MEMORY_MODULE,
    PROCESSOR_MODULE,
    USB_MODULE,
    PCI_MODULE,
    GPIO_MODULE,
    SAS_MODULE,
    NVSRAM_MODULE,
    STORAGE_MODULE,
    TEMPERATURE_MODULE,
    UART_MODULE,
    RTC_MODULE,
    PSU_MODULE,
    TPM_MODULE,
    LED_MODULE,
    NTB_MODULE,
    EXPANDER_MODULE,
    FPGA_MODULE,
    NVMe_MODULE,
};



//Define command type
enum COMMAND_TYPE {
    NO_COMMAND = 0,
    CMD_HELP,
    UNSUPPORT_COMMAND,
    CMD_LIST,
    CMD_SHOW,
    CMD_UTILITY,
    CMD_TEST,
    CMD_ERROR,
    CMD_MAC,
    CMD_EEPROM,
    CMD_SFP,
    CMD_SET,
    CMD_ACCURACY,
    CMD_FAN,
    CMD_LED,
    CMD_TEMP,
    CMD_FW,
    CMD_WWN,
    CMD_FLASH,
    CMD_RISC,
    CMD_GUID,
    CMD_CHARGE,
    CMD_ECC,
    CMD_SPAD,
    CMD_PROGRAM,
};

//Define opration type
enum OPERATION_TYPE
{
    NO_OPRATION = 0,
    OPERATION_HELP,
    UNSUPPORT_OPERATION,
    OPERATION_READ,
    OPERATION_WRITE,
    OPERATION_CONFIG_READ,
    OPERATION_CONFIG_WRITE,
    OPERATION_ALL,
    OPERATION_ERROR_ALL,
    OPERATION_ERROR_STATISTICS,
    OPERATION_ERROR_PCI,
    OPERATION_NODE,
    OPERATION_SN,
    OPERATION_VENDOR,
    OPERATION_CHIP,
    OPERATION_CAPACITY,
	OPERATION_SG_NODE,
    OPERATION_LINK,
    OPERATION_SHOW_LINK,
    OPERATION_SPEED,
    OPERATION_SHOW_SPEED,
    OPERATION_SHOW_WIDTH,
    OPERATION_READPFMC,
    OPERATION_WRITEPFMC,
    OPERATION_WRC,
    OPERATION_EEPROM,
    OPERATION_HBA,
    OPERATION_PCI,
    OPERATION_SWITCH,
    OPERATION_ID,
    OPERATION_CLASS_TYPE,
    OPERATION_PORT_TYPE,
    OPERATION_RETRAIN_LINK,
    OPERATION_RETRAIN,
    OPERATION_DUMP,
    OPERATION_TEST,
    OPERATION_PROGRAM,
    OPERATION_SAVE,
    OPERATION_CLEAR,
    OPERATION_PCI_COMPATIBLE,
    OPERATION_PCIE,
    OPERATION_AER,
    OPERATION_MUXTest,
    OPERATION_PreventionStuck,
    OPERATION_PATH,
    OPERATION_GET,
    OPERATION_SET,
    OPERATION_TEST_RANGE,
    OPERATION_INFO,
    OPERATION_DATALINE,
    OPERATION_ADDRLINE,
    OPERATION_NVSTEST,
    OPERATION_MONITOR,
    OPERATION_STABILITY,
    // SATA operation
    OPERATION_CONTROLLER,
    OPERATION_DRIVE,
    OPERATION_BDF,
    OPERATION_PORT,
    OPERATION_MODEL,
    OPERATION_FW,
    OPERATION_TEMP,
    OPERATION_IDENTIFY,
    OPERATION_SMART,
    OPERATION_WZERO,
    OPERATION_GLIST,
    OPERATION_PLIST,
    OPERATION_TRANSPORT_STATE_TRANSITION_ERR,
    OPERATION_LINK_SEQUENCE_ERR,
    OPERATION_HANDSHAKE_ERR,
    OPERATION_CRC_ERR,
    OPERATION_DISPARITY_ERR,
    OPERATION_10B_TO_8B_DECODE_ERR,
    OPERATION_PHY_INTERNAL_ERR,
    OPERATION_INTERNAL_ERR,
    OPERATION_PROTOCOL_ERR,
    OPERATION_PERSISTENT_COMMUNICATION_OR_DATA_INTEGRITY_ERR,
    OPERATION_TRANSIENT_DATA_INTEGRITY_ERR,
    OPERATION_RECOVER_COMMUNICATIONS_ERR,
    OPERATION_RECOVER_DATA_INTREGRITY_ERR,
    OPERATION_ADDR_LINE,
    OPERATION_DATA_LINE,
    OPERATION_MARCHC,
    OPERATION_PATTERN,
    OPERATION_RANDOM,
    OPERATION_CHECKSUM,
    // STORAGE operation
    OPERATION_SENSE,
    //UART operation 
    OPERATION_UART_PORT_TYPE,
    OPERATION_SHOW_IRQ,
    OPERATION_SCRATCHPAD_TEST,
    OPERATION_INTERNAL_LOOPBACK_TEST,
    OPERATION_ON,
    OPERATION_OFF,
    //SAS operation
    OPERATION_PHY,
    OPERATION_HW,
    OPERATION_DRIVER,
    OPERATION_BIOS,
    OPERATION_RAMDISK,
    OPERATION_ADDRESS,
    OPERATION_ATTACHED_TYPE,
    OPERATION_BLOCK,
    OPERATION_LOGICAL_BLOCK_SIZE,
    OPERATION_PHYSICAL_BLOCK_SIZE,
    OPERATION_INVALID_DWORD_ERR,
    OPERATION_LOSS_DWORD_SYNC,
    OPERATION_PHY_RESET_PRBM,
    OPERATION_RESET_CONTROLLER,
    OPERATION_CHECK,
    OPERATION_FIRMWARE_PID,
    OPERATION_NVDATA_PID,
    OPERATION_FCODE_VERSION,
    OPERATION_UEFI_BSD_VERSION,
    OPERATION_NVDATA_VENDOR,
    OPERATION_DEFAULT_NVDATA_VERSION,
    OPERATION_PERSISTENT_NVDATA_VERSION,
    OPERATION_PROGRAM_FW,
    OPERATION_PROGRAM_ADDRESS,
    OPERATION_PROGRAM_SBR,
    OPERATION_TEMPERATURE,
    OPERATION_TEMPERATURE_THRESHOLD_HI0,
    OPERATION_TEMPERATURE_THRESHOLD_HI1,
    OPERATION_TEMPERATURE_THRESHOLD_LOW0,
    OPERATION_TEMPERATURE_THRESHOLD_LOW1,
    //Ethernet operation
    OPERATION_MDI,
    OPERATION_INTERRUPT,
    OPERATION_EXTERNAL_LOOPBACK_TEST,
    OPERATION_READ_MAC,
    OPERATION_WRITE_MAC,
    OPERATION_READ_EEPROM,
    OPERATION_WRITE_EEPROM,
    OPERATION_VALIDATE_EEPROM,
    OPERATION_READ_SFP,
    OPERATION_WRITE_SFP,
    OPERATION_SINGLE_LOOPBACK_TEST,
    OPERATION_CROSS_LOOPBACK_TEST,
    OPERATION_STATISTIC,
    //Memory Operation
    OPERATION_INJECT,
    OPERATION_SEARCH,
    //BBU operation
    OPERATION_CHARGE,
    //RTC operation
    OPERATION_DATE,
    OPERATION_TIME,
    OPERATION_DATETIME,
    OPERATION_ACCURACY,
    OPERATION_WDT,
    //PSU operation
    OPERATION_PSU,
    OPERATION_FAN,
    OPERATION_LED,
    OPERATION_THRESHOLD,
    OPERATION_PROTOCOL_TYPE,
    OPERATION_PN,
    OPERATION_MAX_POWER,
    OPERATION_RANGE,
    //TPM 
    OPERATION_STATUS,
    OPERATION_SELFTEST,
    OPERATION_FAMILY,
    OPERATION_CMD,
    //CPU operation
    OPERATION_SHOW_CPU,
    OPERATION_SHOW_VENDOR,
    OPERATION_SHOW_MODEL,
    OPERATION_SHOW_FAMILY,
    OPERATION_SHOW_CORE,
    OPERATION_SHOW_FREQUENCY,
    OPERATION_SHOW_STEPPING,
    OPERATION_SHOW_CACHE,
    OPERATION_SHOW_TEMPERATUR,
    OPERATION_UTILITY_GETMCE,
    //NTB
    OPERATION_SEND,
    OPERATION_RECEIVED,
    OPERATION_SERVER,
    OPERATION_CLIENT,
    OPERATION_PERFORMANCE,
    // FPGA
    OPERATION_DESIGN_ID,
    //NVME
    OPERATION_IDENTITY_CONTROLLER,
    OPERATION_IDENTITY_NAMESPACE,
    OPERATION_RESET_SUBSYS,
    OPERATION_NVME_SMART,
    OPERATION_FW_LOG,
    OPERATION_ERROR_LOG,
    OPERATION_FIRMWARE_ACTIVATE,
    OPERATION_FIRMWARE_DOWNLOAD,
    OPERATION_WRITE_ZERO,
    OPERATION_FORMAT,
    OPERATION_GET_FEATURES,
    OPERATION_SET_FEATURES,
    OPERATION_BLOCK_SIZE,
    OPERATION_NODE_NAME,
    OPERATION_BLOCK_NAME,
    OPERATION_NS_ID,
    OPERATION_INIT,
    OPERATION_ENABLE_PORT,
    OPERATION_DISABLE_PORT,
};

//Define global variable
extern COMMAND_TYPE g_command;

#define HELP  "help"



class StringParser
{

    public:
         StringParser();
         ~StringParser();


         int  getModule(string *);
         int  getCommand(string *);
         int  getOperation(string *);
         int  getParameter(string *, int);
         int  getOrigParameter(string *, int);
         int  getParameterNumber(int *);
         
         int  getCommandType(COMMAND_TYPE *);
         int  getOperationType(OPERATION_TYPE *);
         
         int  initialParser(char **, int);

         int  convertToLowcase(char *str);
         int  convertStringToHex(string, int *);
         int  convertStringToHex(string, unsigned long long *);
         int  convertStringToDec(string, int *);
         int  convertIntToArrary(int, int *, int *);
         int  convertHexStringToArrary(string, int *, int *);
         int  isHEXString(string);

    private:
        string m_module;
        string m_command;
        string m_operation;
        string m_parameter[PARAMETERS_NUMBER];
        string m_origParameter[PARAMETERS_NUMBER];
        int m_parameter_count;

        COMMAND_TYPE convertCommandStringToEnum(string);
        OPERATION_TYPE convertOperationStringToEnum(string);
        int check_rearrange_argv(char *parameter);

        COMMAND_TYPE m_command_type;
        OPERATION_TYPE m_operation_type;
};

#endif
