#include "GPIOCommand.hpp"

GPIOCommand::GPIOCommand(COMMAND_TYPE CommandType, string strHelpContent) : CommandBaseClass(CommandType, strHelpContent)
{
    //Base on command type to add different operations
    //printf("%s\n", __func__);


    switch (CommandType)
    {
        case CMD_LIST:
            addOperation(new GPIOOperation(NO_OPRATION, "Not Necessary Parameter."));
            break;
        case CMD_UTILITY:
            addOperation(new GPIOOperation(OPERATION_GET, "Display GPIO All Information."));
            addOperation(new GPIOOperation(OPERATION_SET, "Display GPIO Node Name on OS."));
            break;
        //Add NEW command and operation here
        default:
            break;
    }
}

GPIOCommand::~GPIOCommand()
{

}

int
GPIOCommand::executeCommand(StringParser CommandLine)
{
    INT32 err = 0;
    INT32 OperationIndex;
    COMMAND_TYPE CommandType;
    string strParserOperationName;
    string OperationName;
    
    CommandLine.getOperation(&strParserOperationName);
    CommandLine.getCommandType(&CommandType);

    switch (CommandType)
    {
        case CMD_LIST:
            if ( strParserOperationName != "")
            {
                cout << "Not Necessary Operation Parameter." << endl;
               return -1;
            }
            break;
        case CMD_UTILITY:
            if (strParserOperationName == "help" || strParserOperationName == "")
            {
                listOperation(CommandLine);
                return -1;
            }
            break;
        default:
            cout << "Not supported command" << endl;
            return -1;
            break;
    }

    for (OperationIndex = 0; OperationIndex< m_operation_count; OperationIndex++)
    {
        m_operation[OperationIndex]->getName(&OperationName);
        //printf("m_operation[%d]=%s\n", OperationIndex, OperationName.c_str());
        if (OperationName == strParserOperationName)
        {
            err = m_operation[OperationIndex]->executeOperation(CommandLine);
            break;
        }

    }

    if (OperationIndex == m_operation_count)
    {
        cout << strParserOperationName << " operation not found" << endl;
        return -1;
    }

    return err;
}

