#include "TemperatureCommand.hpp"

TemperatureCommand::TemperatureCommand(COMMAND_TYPE CommandType, string strHelpContent) : CommandBaseClass(CommandType, strHelpContent)
{
    //printf("%s\n", __PRETTY_FUNCTION__);
    //Base on command type to add different operations
    switch (CommandType)
    {
        case CMD_LIST:
            addOperation(new TemperatureOperation(NO_OPRATION, "Not Necessary Parameter."));
            break;
        case CMD_SHOW:
            addOperation(new TemperatureOperation(OPERATION_ALL, "Display Temperature All Information."));
            addOperation(new TemperatureOperation(OPERATION_TEMPERATURE, "Display Temperature Node Name on OS."));
            addOperation(new TemperatureOperation(OPERATION_TEMPERATURE_THRESHOLD_HI0, "Display Temperature Threshold0."));
            addOperation(new TemperatureOperation(OPERATION_TEMPERATURE_THRESHOLD_HI1, "Display Temperature Threshold1."));
            addOperation(new TemperatureOperation(OPERATION_TEMPERATURE_THRESHOLD_LOW0, "Display Temperature Threshold2."));
            addOperation(new TemperatureOperation(OPERATION_TEMPERATURE_THRESHOLD_LOW1, "Display Temperature Threshold3."));
            break;
        case CMD_UTILITY:
            addOperation(new TemperatureOperation(OPERATION_WRITE, "Temperature/Threshold Read"));
            addOperation(new TemperatureOperation(OPERATION_READ, "High/Low Threshold Write"));
            break;
        //Add NEW command and operation here
        default:
            break;
    }
}

TemperatureCommand::~TemperatureCommand()
{

}

int
TemperatureCommand::executeCommand(StringParser CommandLine)
{
    //printf("%s\n", __PRETTY_FUNCTION__);
    INT32 err = 0;
    INT32 OperationIndex;
    COMMAND_TYPE CommandType;
    string strParserOperationName;
    string OperationName;
    
    CommandLine.getOperation(&strParserOperationName);
    CommandLine.getCommandType(&CommandType);

    switch (CommandType)
    {
        case CMD_LIST:
            if ( strParserOperationName != "")
            {
                cout << "Not Necessary Operation Parameter." << endl;
               return -1;
            }
            break;
        case CMD_SHOW:
        case CMD_UTILITY:
            if (strParserOperationName == "help" || strParserOperationName == "")
            {
                listOperation(CommandLine);
                return -1;
            }
            break;
        default:
            cout << "Not supported command" << endl;
            return -1;
            break;
    }

    for (OperationIndex = 0; OperationIndex< m_operation_count; OperationIndex++)
    {
        m_operation[OperationIndex]->getName(&OperationName);
        //printf("m_operation[%d]=%s\n", OperationIndex, OperationName.c_str());
        if (OperationName == strParserOperationName)
        {
            err = m_operation[OperationIndex]->executeOperation(CommandLine);
            break;
        }

    }

    if (OperationIndex == m_operation_count)
    {
        cout << strParserOperationName << " operation not found" << endl;
        return -1;
    }

    return err;
}

