#ifndef TPMOperation_H
#define TPMOperation_H

#include "OperationBaseClass.hpp"
#include "TPMDAPI.hpp"

#define TPM_DEBUG_LEVEL     DEBUG_LEVEL_1
//#define TPM_DEBUG_LEVEL   DEBUG_LEVEL_2 //debug mode


class TPMOperation : public OperationBaseClass
{
    public:
                 TPMOperation(OPERATION_TYPE, string);
        virtual ~TPMOperation();

        int executeOperation(StringParser command_line);

    private:
        int             m_s32Result;
        TPMDAPI*        m_pTPMDAPI;
        ErrorMsg*       m_pErrorMsg;
        string          m_strParameter[PARAMETER_NUMBER];
        int             m_s32ParameterAmount;
        UINT8*          m_u8pRspBuffer;
        UINT32          m_u32RspSize; //size the TPM feedback
        TPM_CMD_INPUT   m_cmdList;

        void    showHelp();
        int     checkSyntax(StringParser);
        int     sendCommandManually();
        
        int     showInfo();

        void    showData(OPERATION_TYPE     in_opType,
                         UINT8*             in_u8pRspBuffer);
        
        int     showAllInfo(TPM_CMD_INPUT  in_cmdList,
                            UINT8*         out_u8pRspBuffer,
                            UINT32         in_u32RspBufferSize,
                            UINT32*        out_u32pRspSize);

        int     getSpecificInfo(TPM_CMD_INPUT   in_cmdList,
                                OPERATION_TYPE  in_opType,
                                UINT8*          out_u8pRspBuffer,
                                UINT32          in_u32RspBufferSize,
                                UINT32*         out_u32pRspSize);

        //int     showFirmwareVersion(TPM_CMD_INPUT);
        //int     showVendor(TPM_CMD_INPUT);
        //int     showStatus(TPM_CMD_INPUT);
        //int     showFamily(TPM_CMD_INPUT);


        void    showBitState(STRING    in_string,    
                             UINT8     in_u8Data);

        int     TxRxCmd(TPM_CMD_INPUT     in_cmdList,
                        UINT8*            out_u8pRspBuffer,
                        UINT32            in_u32RspBufferSize,
                        UINT32*           out_u32pRspSize); //size the TPM feedback


        int     doTpmSelfTest();
};

#endif
