/****************************************************************************
*                                                                           *
* Copyright 2004-2011 NetApp Inc. All rights reserved. This file is         *
* confidential and a trade secret of NetApp Inc. The receipt or             *
* possession of this file does not convey any rights to reproduce or        *
* disclose its contents or to manufacture, use, or sell anything it may     *
* describe, in whole, or in part, without the specific written consent of   *
* NetApp Inc.                                                               *
*                                                                           *
****************************************************************************/
/****************************************************************************
*                                                                           *
* NAME            odmdefine.h                                               *
* SUMMARY                                                                   *
* VERSION         %version: %                                               *
* UPDATE DATE     %date_modified: %                                         *
* PROGRAMMER      %created_by:    Merck Hung %                              *
*                                                                           *
*        Copyright 2002-2011 NetApp Inc. All Rights Reserved.               *
*                                                                           *
* DESCRIPTION:                                                              *
*                                                                           *
****************************************************************************/


//
// Definitions
//
#define DISK_NAME_SAS_0		"sas0disk"
#define DISK_NAME_SAS_1		"sas1disk"
#define DISK_NAME_SAS_2		"sas2disk"
#define DISK_NAME_SAS_3		"sas3disk"
#define DISK_NAME_SAS_4		"sas4disk"
#define DISK_NAME_SAS_5     "sas5disk"
#define DISK_NAME_SAS_6     "sas6disk"
#define DISK_NAME_SAS_7     "sas7disk"
#define DISK_NAME_SAS_8     "sas8disk"

#define DISK_NAME_RAM_0     "ram0disk"
#define DISK_NAME_RAM_1     "ram1disk"
#define DISK_NAME_RAM_2     "ram2disk"
#define DISK_NAME_RAM_3     "ram3disk"
#define DISK_NAME_RAM_4     "ram4disk"
#define DISK_NAME_RAM_5     "ram5disk"
#define DISK_NAME_RAM_6     "ram6disk"
#define DISK_NAME_RAM_7     "ram7disk"
#define DISK_NAME_RAM_8     "ram8disk"

#define DISK_NAME_SATA_0    "sata0disk"
#define DISK_NAME_SATA_1    "sata1disk"
#define DISK_NAME_SATA      "satadummydisk"

#define DISK_NAME_USB		"usbdisk"
#define DISK_NAME_OTHER		"otherdisk"
#define DISK_NAME_FC		"fc_ramdisk"

#define RAMDISK_VENDOR		"Linux"
#define FC_RAMDISK_VENDOR	"SCST_FIO"
#define SATA_VENDOR         "ATA"
#define SATA_PROC_NAME      "ahci"
#define USB_PROC_NAME       "usb-storage"
#define SAS_PROC_NAME       "mpt3sas"
#define MAX_SAS_HOSTS		9
#define MAX_SATA_HOSTS      6
#define MAX_USB_HOSTS       2

enum {
    SCSI_SATA_TYPE = 0,
    SCSI_USB_TYPE,
    SCSI_SAS_TYPE
};

enum {
    SCSI_HOST_SAS_0 = 0,
    SCSI_HOST_SAS_1,
    SCSI_HOST_SAS_2,
    SCSI_HOST_SAS_3,
    SCSI_HOST_SAS_4,
    SCSI_HOST_SAS_5,
    SCSI_HOST_SAS_6,
    SCSI_HOST_SAS_7,
    SCSI_HOST_SAS_8,
};

enum {  // depend on Arapaho HW design
    SCSI_HOST_SATA_0 = 1,
    SCSI_HOST_SATA_1 = 5,
};

enum {
    SCSI_HOST_USB = 0,
};

enum {
    SCSI_HOST_DUMMY_0,
    SCSI_HOST_DUMMY_1,
    SCSI_HOST_DUMMY_2,
    SCSI_HOST_DUMMY_3,
};

typedef struct _hostNoMatch
{
	unsigned int	hostNo;
	char			*prefixName;
	unsigned int	*counter;

} hostNoMatch_t;


//
// Prototypes
//
int lookupODMDefinedName( struct scsi_device *sdp, char **name, int **cnt );
int odmFormatDiskName( char *prefix, int index, char *buf, int buflen );

