/// @file       FPGADAPI.hpp
/// @brief      FPGADAPI class
/// @details    Provide diagnostic and utility APIs for FPGA module
/// @author     KenHu
/// @copyright  Copyright 2015-2016 Hon Hai Technology Group. All Rights Reserved.

#ifndef FPGA_DAPI_HPP
#define FPGA_DAPI_HPP

#include "BaseClassDAPI.hpp"
#include "FPGADDAPI.hpp"

/// @class      FPGADAPI FPGADAPI.hpp "FPGADAPI.hpp"
/// @brief      Provide diagnostic and utility APIs for FPGA module
/// @param      m_pFPGADDAPI is a pointer to FPGA DDAPI class
class FPGADAPI : public BaseClassDAPI
{
    public: 
                            FPGADAPI(STRING in_szClassName);
        virtual             ~FPGADAPI(void);
        
        ErrorMsg*           getDeviceList(list<string>  *out_pList);
        ErrorMsg*           getSPADInfo(string  in_strDeviceName,
                                        UINT32 *out_u32pStartOffset,
                                        UINT32 *out_u32pTotalSize);

        ErrorMsg*           readReg(string  in_strDeviceName,
                                    UINT32  in_u32Offset,
                                    string  *out_strpValue);
        ErrorMsg*           readSPAD(string  in_strDeviceName,
                                     UINT32  in_u32Offset,
                                     string  *out_strpValue);

        ErrorMsg*           writeReg(string in_strDeviceName,
                                     UINT32 in_u32Offset,
                                     string in_strValue);
        ErrorMsg*           writeSPAD(string in_strDeviceName,
                                      UINT32 in_u32Offset,
                                      string in_strValue);
    protected:

    private:
        FPGADDAPI*           m_pFPGADDAPI;
};

#endif

