#include "NTBDAPI.hpp"

NTBDAPI::NTBDAPI(STRING className) : BaseClassDAPI(className)
{
    m_pNTBDriverAPI = new NTBDDAPI("NTBDDAPI");
}

NTBDAPI::~NTBDAPI()
{
    if(m_pNTBDriverAPI != NULL)
    {
        delete m_pNTBDriverAPI;
        m_pNTBDriverAPI = NULL;
    }
}

ErrorMsg*
NTBDAPI::searchDevice(vector<NTB_INFO>*  out_pNtbList)
{
    m_pErrorMsg = m_pNTBDriverAPI->searchDevice(out_pNtbList);
    if(m_pErrorMsg != NO_ERROR_MSG)
    {
        m_pErrorMsg = returnErrorMsg(ERROR_NTB_DAPI_SEARCH_DEVICE, NULL, m_pErrorMsg); 
    }
    return m_pErrorMsg;
}

ErrorMsg*
NTBDAPI::receiver(UINT64  in_u64PatternRev,
                  UINT64  in_u64Loop)
{
    m_pErrorMsg = m_pNTBDriverAPI->receiver(in_u64PatternRev, in_u64Loop);
    if(m_pErrorMsg != NO_ERROR_MSG)
    {
        m_pErrorMsg = returnErrorMsg(ERROR_NTB_DAPI_RECEIVER, NULL, m_pErrorMsg);
    }
    return m_pErrorMsg;
}

ErrorMsg*
NTBDAPI::testPerformance(UINT64  in_u64PatternSend,
                         UINT64  in_u64BlockSize,
                         UINT64  in_u64Loop)
{
    m_pErrorMsg = m_pNTBDriverAPI->testPerformance(in_u64PatternSend, in_u64BlockSize, in_u64Loop);
    if(m_pErrorMsg != NO_ERROR_MSG)
    {
        m_pErrorMsg = returnErrorMsg(ERROR_NTB_DAPI_PERFORMANCE, NULL, m_pErrorMsg);
    }
    return m_pErrorMsg;
}


//in_64Loop = 0 : infinite loop (TBC)
ErrorMsg*
NTBDAPI::stress(UINT64  in_u64PatternSend,
                UINT64  in_u64PatternRev,
                UINT64  in_u64Loop,
                bool    in_bShowPerformance,
                bool    in_bCheckData)
{
    if(in_bShowPerformance)
    {
        //m_pErrorMsg = m_pNTBDriverAPI->stressShowPerformance(in_u64PatternSend, in_u64PatternRev, in_u64Loop);
    }
    else 
    {
        m_pErrorMsg = m_pNTBDriverAPI->stress(in_u64PatternSend, in_u64PatternRev, in_u64Loop, in_bCheckData);
    }

    if(m_pErrorMsg != NO_ERROR_MSG)
    {
        m_pErrorMsg = returnErrorMsg(ERROR_NTB_DAPI_SEND, NULL, m_pErrorMsg);
    }
    return m_pErrorMsg;
}



ErrorMsg*
NTBDAPI::server(string  in_name,
                UINT64  in_u64PatternSend,
                UINT64  in_u64PatternRev,
                UINT32  in_u32Loop)
{
    m_pErrorMsg = m_pNTBDriverAPI->server(in_name, in_u64PatternSend, in_u64PatternRev, in_u32Loop);
    if(m_pErrorMsg != NO_ERROR_MSG)
    {
        m_pErrorMsg = returnErrorMsg(ERROR_NTB_DAPI_SEND, NULL, m_pErrorMsg);
    }
    return m_pErrorMsg;
}

ErrorMsg*
NTBDAPI::client(string  in_name,
                UINT64  in_u64PatternRev,
                UINT64  in_u64PatternSend,
                UINT32  in_u32Loop)
{
    m_pErrorMsg = m_pNTBDriverAPI->client(in_name, in_u64PatternRev, in_u64PatternSend, in_u32Loop);
    if(m_pErrorMsg != NO_ERROR_MSG)
    {
        m_pErrorMsg = returnErrorMsg(ERROR_NTB_DAPI_RECEIVER, NULL, m_pErrorMsg);
    }
    return m_pErrorMsg;
    
}

ErrorMsg*
NTBDAPI::initialWindow()
{
    m_pErrorMsg = m_pNTBDriverAPI->initialWindow();
    if(m_pErrorMsg != NO_ERROR_MSG)
    {
        m_pErrorMsg = returnErrorMsg(ERROR_NTB_DAPI_INIT, NULL, m_pErrorMsg);
    }
    return m_pErrorMsg;
}
