#ifndef RTC_DDAPI_H
#define RTC_DDAPI_H

#include "BaseClassDDAPI.hpp"

#define RTC_DEV                             "/dev/rtc0"

#define PIT_SYSTEM_COUNTER_IOPORT		    0x40
#define PIT_CONTROL_COUNTER_IOPORT		    0x43

#define TIEMER_ACCURACY_TEST_TIME           31250   // Set 31.25 ms for RTC periodic select 
#define TIEMER_ACCURACY_UPPER_BOUND         580
#define TIEMER_ACCURACY_LOWER_BOUND         -540
typedef enum
{    
    PIT_MODE0 = 0,
    PIT_MODE1,
    PIT_MODE2,
    PIT_MODE3,
    PIT_MODE4,
    PIT_MODE5,
    
} PIT_TIMER_MODE;

class RTCDDAPI : public BaseClassDDAPI
{
public:
                        RTCDDAPI(STRING className);
                        ~RTCDDAPI(void);

         ErrorMsg*      showDateTime(void);
         ErrorMsg*      setDate(int year, int month, int date);
         ErrorMsg*      setTime(int hour, int minute, int second);
         //RTC
         ErrorMsg*      setRTCRate(FLOAT timerRate);
         ErrorMsg*      startRTC(void);
         void           stopRTC(void);
         ErrorMsg*      waitRTCInterrupt(void);
         //8254
         void           startPIT(UINT32 timerCount);
         void           stopPIT(void);
         void           convertPITTimeToCount(FLOAT usTime, UINT32* timerCount);
         void           readPIT(UINT32* currentValue);

		 ErrorMsg*      rtcWDTTest(void);
protected:

private:
         void           setPITControlWord(PIT_TIMER_MODE PITMode);
         
         INT32          m_rtcDevNode;
         CHAR           m_tmpString[100];
         PIT_TIMER_MODE m_PITMode;
         UINT32         m_rtcRate;
};

#endif

