#include "Temperature_PSU.hpp"



Temperature_PSU :: Temperature_PSU(STRING  ClassName) : TemperatureGeneric(ClassName)
{
    m_PSUDdapi = new PSUDDAPI();
    if(m_PSUDdapi != NULL)
    {
        //m_PSUDdapi->generateSATAList();
    }



}



Temperature_PSU :: ~Temperature_PSU()
{
    if(m_PSUDdapi != NULL)
        delete m_PSUDdapi;
}


ErrorMsg*  Temperature_PSU :: getTemperatureNameList(list<string> *pTemperatureList)
{
    //printf("%s\n", __PRETTY_FUNCTION__);;
    ErrorMsg*   pErrorMsg = NO_ERROR_MSG;

    string tempString;
    tempString.clear();
    //->getTemperatureList(out_pList)
    pErrorMsg = m_PSUDdapi->getTemperatureList(pTemperatureList);

    if(pErrorMsg == NO_ERROR_MSG)
    {
        //pTemperatureList->push_front(tempString);
    }
    else
    {
        //return XXXXXXXXX Error Message XXXXX
    }



    return pErrorMsg;
}


ErrorMsg*  Temperature_PSU :: getDataByName(STRING WellKnownName,
                                               TEMPERATURE_DATA_ELEMENT TemperatureDataElement,
                                               list<string> *returnDataInfo)
{

    //printf("%s\n", __PRETTY_FUNCTION__);

    //ErrorMsg*   pErrorMsg = NO_ERROR_MSG;
    string tempString;
    tempString.clear();
    char *pch;
    char tempName[256];
    sprintf(tempName, "%s", WellKnownName);

    pch = strtok(tempName, "_");

/*
    printf("%s\n", __func__);
    printf("WellKnownName:%s\n", WellKnownName);
    printf("TemperatureDataElement:%d\n", TemperatureDataElement);
*/


    switch(TemperatureDataElement)
    {
        case TEMPERATURE_DATA_ALL_INFO:
            //TemperatureDataElement=TEMPERATURE_DATA_ALL_INFO;
            break;
        case TEMPERATURE_DATA_CURRENT_TEMPERATURE:
        	//sprintf(WellKnownName,"%s_%s",WellKnownName,"_temp0");
        	//tempString=WellKnownName;
        	//tempString.append("_temp0");
        	getCurrentTemperatureList(tempString.c_str(), returnDataInfo);
            //pErrorMsg = getCurrentTemperatureList(tempString.c_str(), returnDataInfo);
            break;
/*
        case TEMPERATURE_DATA_CURRENT_TEMPERATURE1:
        	tempString=WellKnownName;
        	tempString.append("_temp1");
            pErrorMsg = getCurrentTemperatureList(tempString.c_str(), returnDataInfo);
            break;

        case TEMPERATURE_DATA_CURRENT_TEMPERATURE2:
        	tempString=WellKnownName;
        	tempString.append("_temp2");
            pErrorMsg = getCurrentTemperatureList(tempString.c_str(), returnDataInfo);
            break;

        case TEMPERATURE_DATA_CURRENT_TEMPERATURE3:
        	tempString=WellKnownName;
        	tempString.append("_temp3");
            pErrorMsg = getCurrentTemperatureList(tempString.c_str(), returnDataInfo);
            break;
*/
        case TEMPERATURE_DATA_THRESHOLD_HIGH0:
        	tempString=pch;
        	tempString.append("_over_temp_threshold");
        	getThresholdHigh0List(tempString.c_str(), returnDataInfo);
            //pErrorMsg = getThresholdHigh0List(tempString.c_str(), returnDataInfo);
            break;

        case TEMPERATURE_DATA_THRESHOLD_HIGH1:
        	getThresholdHigh1List(WellKnownName, returnDataInfo);
            //pErrorMsg = getThresholdHigh1List(WellKnownName, returnDataInfo);
            break;

        case TEMPERATURE_DATA_THRESHOLD_LOW0:
        	tempString=pch;
        	tempString.append("_under_temp_threshold");
        	getThresholdLow0List(tempString.c_str(), returnDataInfo);
            //pErrorMsg = getThresholdLow0List(tempString.c_str(), returnDataInfo);
            break;

        case TEMPERATURE_DATA_THRESHOLD_LOW1:
        	getThresholdLow1List(WellKnownName, returnDataInfo);
            //pErrorMsg = getThresholdLow1List(WellKnownName, returnDataInfo);
            break;

        default:
            //return -1;
            break;
    }

    return NO_ERROR_MSG;
}

ErrorMsg*  Temperature_PSU :: setDataByName(STRING WellKnownName,
											TEMPERATURE_DATA_ELEMENT TemperatureDataElement,
											string SetValue)
{
    //printf("%s\n", __PRETTY_FUNCTION__);

    //ErrorMsg*   pErrorMsg = NO_ERROR_MSG;
    string tempString;
    tempString.clear();

    char *pch;
    char tempName[256];
    sprintf(tempName, "%s", WellKnownName);

    pch = strtok(tempName, "_");


/*
    printf("%s\n", __func__);
    printf("WellKnownName:%s\n", WellKnownName);
    printf("TemperatureDataElement:%d\n", TemperatureDataElement);
*/


    switch(TemperatureDataElement)
    {
        case TEMPERATURE_DATA_ALL_INFO:
            //TemperatureDataElement=TEMPERATURE_DATA_ALL_INFO;
            break;
        case TEMPERATURE_DATA_CURRENT_TEMPERATURE:
            break;
        case TEMPERATURE_DATA_THRESHOLD_HIGH0:
        	tempString=pch;
        	tempString.append("_over_temp_threshold");
        	setThresholdHigh0List(tempString.c_str(), SetValue);
            //pErrorMsg = setThresholdHigh0List(tempString.c_str(), SetValue);
            break;

        case TEMPERATURE_DATA_THRESHOLD_HIGH1:
        	setThresholdHigh1List(WellKnownName, SetValue);
            //pErrorMsg = setThresholdHigh1List(WellKnownName, SetValue);
            break;

        case TEMPERATURE_DATA_THRESHOLD_LOW0:
        	tempString=pch;
        	tempString.append("_under_temp_threshold");
        	setThresholdLow0List(tempString.c_str(), SetValue);
            //pErrorMsg = setThresholdLow0List(tempString.c_str(), SetValue);
            break;

        case TEMPERATURE_DATA_THRESHOLD_LOW1:
        	setThresholdLow1List(WellKnownName, SetValue);
            //pErrorMsg = setThresholdLow1List(WellKnownName, SetValue);
            break;

        default:
            //return -1;
            break;
    }


	return NO_ERROR_MSG;
}



ErrorMsg* Temperature_PSU :: getCurrentTemperatureList(STRING WellKnownName,
                                                        list<string> *returnDataInfo)
{
    //printf("%s\n", __PRETTY_FUNCTION__);

	ERRORCODE errorCode = NO_ERROR;
    ErrorMsg*   pErrorMsg = NO_ERROR_MSG;
    string tempString;
    tempString.clear();

	pErrorMsg = m_PSUDdapi->getTemperature(WellKnownName,  &tempString);

    if (pErrorMsg != NO_ERROR_MSG)
    {
    	return returnErrorMsg((ERRORCODE)(ERROR_TEMPERATURE_DDAPI_GET_CURRENT_TEMPERATURE | errorCode), NULL, pErrorMsg);
    }
    else
    {
    	returnDataInfo->push_back(tempString);
    }
    return NO_ERROR_MSG;
}



ErrorMsg*   Temperature_PSU :: getThresholdHigh0List(STRING WellKnownName,
                                                     list<string> *returnDataInfo)
{
    ErrorMsg*   pErrorMsg = NO_ERROR_MSG;
    string tempString;
    tempString.clear();

/*
    printf("%s\n", __func__);
    printf("WellKnownName:%s\n", WellKnownName);
*/


	pErrorMsg = m_PSUDdapi->getTemperatureThreshold(WellKnownName,  &tempString);

    if (pErrorMsg != NO_ERROR_MSG)
    {
        //return returnErrorMsg(ERROR_TEMPERATURE_DAPI_DISPLAY_TEMPERATURE_LIST, NULL, m_errorCode);
    }
    else
    {
    	returnDataInfo->push_back(tempString);
    }
    return NO_ERROR_MSG;
}


ErrorMsg*   Temperature_PSU :: getThresholdLow0List(STRING WellKnownName,
                                                    list<string> *returnDataInfo)
{
    ErrorMsg*   pErrorMsg = NO_ERROR_MSG;
    string tempString;
    tempString.clear();

/*
    printf("%s\n", __func__);
    printf("WellKnownName:%s\n", WellKnownName);
*/


	pErrorMsg = m_PSUDdapi->getTemperatureThreshold(WellKnownName,  &tempString);

    if (pErrorMsg != NO_ERROR_MSG)
    {
        //return returnErrorMsg(ERROR_TEMPERATURE_DAPI_DISPLAY_TEMPERATURE_LIST, NULL, m_errorCode);
    }
    else
    {
    	returnDataInfo->push_back(tempString);
    }
    return NO_ERROR_MSG;
}





ErrorMsg*   Temperature_PSU :: getThresholdHigh1List(STRING WellKnownName,
                                                     list<string> *returnDataInfo)
{
    //printf("%s\n", __PRETTY_FUNCTION__);
/*

    ErrorMsg*   pErrorMsg = NO_ERROR_MSG;
    string tempString;
    tempString.clear();

    pErrorMsg = m_PSUDdapi->getDataByName(WellKnownName,  eDriveTemperature, &tempString);

    //printf("tempString=%s\n", tempString.c_str());
    if (pErrorMsg != NO_ERROR_MSG)
    {
        //return returnErrorMsg(ERROR_TEMPERATURE_DAPI_DISPLAY_TEMPERATURE_LIST, NULL, m_errorCode);
    }

    returnDataInfo->push_back(tempString);
*/

    return NO_ERROR_MSG;
}


ErrorMsg*   Temperature_PSU :: getThresholdLow1List(STRING WellKnownName,
                                                    list<string> *returnDataInfo)
{
    //printf("%s\n", __PRETTY_FUNCTION__);

/*

    ErrorMsg*   pErrorMsg = NO_ERROR_MSG;
    string tempString;
    tempString.clear();

    pErrorMsg = m_PSUDdapi->getDataByName(WellKnownName,  eDriveTemperature, &tempString);

    //printf("tempString=%s\n", tempString.c_str());
    if (pErrorMsg != NO_ERROR_MSG)
    {
        //return returnErrorMsg(ERROR_TEMPERATURE_DAPI_DISPLAY_TEMPERATURE_LIST, NULL, m_errorCode);
    }

    returnDataInfo->push_back(tempString);
*/

    return NO_ERROR_MSG;
}

ErrorMsg*   Temperature_PSU :: setThresholdHigh0List(STRING WellKnownName, string SetValue)
{
    ErrorMsg*   pErrorMsg = NO_ERROR_MSG;
    string tempString;
    tempString.clear();

/*
    printf("%s\n", __func__);
    printf("WellKnownName:%s\n", WellKnownName);
*/


	pErrorMsg = m_PSUDdapi->setTemperatureThreshold(WellKnownName,  SetValue);

    if (pErrorMsg != NO_ERROR_MSG)
    {
        //return returnErrorMsg(ERROR_TEMPERATURE_DAPI_DISPLAY_TEMPERATURE_LIST, NULL, m_errorCode);
    }


	return NO_ERROR_MSG;
}
ErrorMsg*   Temperature_PSU :: setThresholdLow0List(STRING WellKnownName, string SetValue)
{

	return NO_ERROR_MSG;
}
ErrorMsg*   Temperature_PSU :: setThresholdHigh1List(STRING WellKnownName, string SetValue)
{

	return NO_ERROR_MSG;
}

ErrorMsg*   Temperature_PSU :: setThresholdLow1List(STRING WellKnownName, string SetValue)
{

	return NO_ERROR_MSG;
}

/*

ErrorMsg*
Temperature_PSU :: Setup_resource_path(string path, int cpu_id_index)
{
   resource_path = path;
   index = cpu_id_index;

   return NO_ERROR_MSG;
}
*/


/*

string
Temperature_PSU :: Get_name()
{
   string file, str_index, name;
   char   str_tmp[100];
   FILE   *fPtr;
   
   sprintf(str_tmp, "%d", index);
   str_index = str_tmp;
   file = resource_path + "temp" + str_index + "_label";

   fPtr = fopen(file.c_str(), "r");
   if (fPtr == NULL)
   {
       printf("Temperature_PSU Get_name() file open fail...\n");
       return "";
   }

   fgets(str_tmp, 100, fPtr);
   name = str_tmp;
   name.erase(name.end() - 1);

   fclose(fPtr);

   return name;
}
*/


/*

ErrorMsg*
Temperature_PSU :: Get_current_temperature(float *temp)
{
   string file, str_index;
   char   str_tmp[100];
   FILE   *fPtr;
   float  tmp_temp;
   
   sprintf(str_tmp, "%d", index);
   str_index = str_tmp;
   file = resource_path + "temp" + str_index + "_input";

   fPtr = fopen(file.c_str(), "r");
   if (fPtr == NULL)
   {
       //printf("Temperature_PSU Get_current_temperature() file open fail...\n");
       file = "CPU:" + file;
       return returnErrorMsg((ERRORCODE)(ERROR_TEMPERATURE_DDAPI_GET_CURRENT_TEMPERATURE | ERROR_OPEN_FILE), file.c_str(), NULL);
   }

   fgets(str_tmp, 100, fPtr);
   sscanf(str_tmp, "%f", &tmp_temp);
   tmp_temp = tmp_temp / 1000.0;
   //printf("Temp:%f\n",tmp_temp);
   *temp = tmp_temp;

   fclose(fPtr);

   return NO_ERROR_MSG;
}
*/


/*

ErrorMsg*
Temperature_PSU :: Get_threshold_hight(float *temp)
{
   string file, str_index;
   char   str_tmp[100];
   FILE   *fPtr;
   float  tmp_temp;
   
   sprintf(str_tmp, "%d", index);
   str_index = str_tmp;
   file = resource_path + "temp" + str_index + "_max";

   fPtr = fopen(file.c_str(), "r");
   if (fPtr == NULL)
   {
       //printf("Temperature_PSU Get_threshold_hight() file open fail...\n");
       file = "CPU:" + file;
       return returnErrorMsg((ERRORCODE)(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT | ERROR_OPEN_FILE), file.c_str(), NULL);
   }

   fgets(str_tmp, 100, fPtr);
   sscanf(str_tmp, "%f", &tmp_temp);
   tmp_temp = tmp_temp / 1000.0;
   //printf("Temp:%f\n",tmp_temp);
   *temp = tmp_temp;

   fclose(fPtr);

   return NO_ERROR_MSG;
}
*/


/*

ErrorMsg*
Temperature_PSU :: Get_threshold_low(float *temp)
{
   //printf("Get_threshold_low() CPU not support.\n");
   return returnErrorMsg((ERRORCODE)(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_LOW ), "Get_threshold_low() CPU not support.", NULL);
}
*/



/*ErrorMsg*
Temperature_PSU :: Set_name(string name)
{
   return NO_ERROR_MSG;
}*/


/*

ErrorMsg*
Temperature_PSU :: Set_threshold_hight(float temp)
{
   //printf("Set_threshold_hight() CPU not support.\n");
   return returnErrorMsg((ERRORCODE)(ERROR_TEMPERATURE_DDAPI_SET_THRESHOLD_HIGHT), "Set_threshold_hight() CPU not support.", NULL);
}
*/


/*

ErrorMsg*
Temperature_PSU :: Set_threshold_low(float temp)
{
   //printf("Set_threshold_low() CPU not support.\n");
   return returnErrorMsg((ERRORCODE)(ERROR_TEMPERATURE_DDAPI_SET_THRESHOLD_LOW), "Set_threshold_low() CPU not support.", NULL);
}
*/



